(function () {
    'use strict';

    /*! *****************************************************************************
    Copyright (c) Microsoft Corporation.

    Permission to use, copy, modify, and/or distribute this software for any
    purpose with or without fee is hereby granted.

    THE SOFTWARE IS PROVIDED "AS IS" AND THE AUTHOR DISCLAIMS ALL WARRANTIES WITH
    REGARD TO THIS SOFTWARE INCLUDING ALL IMPLIED WARRANTIES OF MERCHANTABILITY
    AND FITNESS. IN NO EVENT SHALL THE AUTHOR BE LIABLE FOR ANY SPECIAL, DIRECT,
    INDIRECT, OR CONSEQUENTIAL DAMAGES OR ANY DAMAGES WHATSOEVER RESULTING FROM
    LOSS OF USE, DATA OR PROFITS, WHETHER IN AN ACTION OF CONTRACT, NEGLIGENCE OR
    OTHER TORTIOUS ACTION, ARISING OUT OF OR IN CONNECTION WITH THE USE OR
    PERFORMANCE OF THIS SOFTWARE.
    ***************************************************************************** */

    function __rest(s, e) {
        var t = {};
        for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p) && e.indexOf(p) < 0)
            t[p] = s[p];
        if (s != null && typeof Object.getOwnPropertySymbols === "function")
            for (var i = 0, p = Object.getOwnPropertySymbols(s); i < p.length; i++) {
                if (e.indexOf(p[i]) < 0 && Object.prototype.propertyIsEnumerable.call(s, p[i]))
                    t[p[i]] = s[p[i]];
            }
        return t;
    }

    var commonjsGlobal = typeof globalThis !== 'undefined' ? globalThis : typeof window !== 'undefined' ? window : typeof global !== 'undefined' ? global : typeof self !== 'undefined' ? self : {};

    function getAugmentedNamespace(n) {
    	if (n.__esModule) return n;
    	var a = Object.defineProperty({}, '__esModule', {value: true});
    	Object.keys(n).forEach(function (k) {
    		var d = Object.getOwnPropertyDescriptor(n, k);
    		Object.defineProperty(a, k, d.get ? d : {
    			enumerable: true,
    			get: function () {
    				return n[k];
    			}
    		});
    	});
    	return a;
    }

    var dist = {};

    var Service$1 = {};

    var DataHelper$1 = {};

    var js_cookie = {exports: {}};

    /*!
     * JavaScript Cookie v2.2.1
     * https://github.com/js-cookie/js-cookie
     *
     * Copyright 2006, 2015 Klaus Hartl & Fagner Brack
     * Released under the MIT license
     */

    (function (module, exports) {
    (function (factory) {
    	var registeredInModuleLoader;
    	{
    		module.exports = factory();
    		registeredInModuleLoader = true;
    	}
    	if (!registeredInModuleLoader) {
    		var OldCookies = window.Cookies;
    		var api = window.Cookies = factory();
    		api.noConflict = function () {
    			window.Cookies = OldCookies;
    			return api;
    		};
    	}
    }(function () {
    	function extend () {
    		var i = 0;
    		var result = {};
    		for (; i < arguments.length; i++) {
    			var attributes = arguments[ i ];
    			for (var key in attributes) {
    				result[key] = attributes[key];
    			}
    		}
    		return result;
    	}

    	function decode (s) {
    		return s.replace(/(%[0-9A-Z]{2})+/g, decodeURIComponent);
    	}

    	function init (converter) {
    		function api() {}

    		function set (key, value, attributes) {
    			if (typeof document === 'undefined') {
    				return;
    			}

    			attributes = extend({
    				path: '/'
    			}, api.defaults, attributes);

    			if (typeof attributes.expires === 'number') {
    				attributes.expires = new Date(new Date() * 1 + attributes.expires * 864e+5);
    			}

    			// We're using "expires" because "max-age" is not supported by IE
    			attributes.expires = attributes.expires ? attributes.expires.toUTCString() : '';

    			try {
    				var result = JSON.stringify(value);
    				if (/^[\{\[]/.test(result)) {
    					value = result;
    				}
    			} catch (e) {}

    			value = converter.write ?
    				converter.write(value, key) :
    				encodeURIComponent(String(value))
    					.replace(/%(23|24|26|2B|3A|3C|3E|3D|2F|3F|40|5B|5D|5E|60|7B|7D|7C)/g, decodeURIComponent);

    			key = encodeURIComponent(String(key))
    				.replace(/%(23|24|26|2B|5E|60|7C)/g, decodeURIComponent)
    				.replace(/[\(\)]/g, escape);

    			var stringifiedAttributes = '';
    			for (var attributeName in attributes) {
    				if (!attributes[attributeName]) {
    					continue;
    				}
    				stringifiedAttributes += '; ' + attributeName;
    				if (attributes[attributeName] === true) {
    					continue;
    				}

    				// Considers RFC 6265 section 5.2:
    				// ...
    				// 3.  If the remaining unparsed-attributes contains a %x3B (";")
    				//     character:
    				// Consume the characters of the unparsed-attributes up to,
    				// not including, the first %x3B (";") character.
    				// ...
    				stringifiedAttributes += '=' + attributes[attributeName].split(';')[0];
    			}

    			return (document.cookie = key + '=' + value + stringifiedAttributes);
    		}

    		function get (key, json) {
    			if (typeof document === 'undefined') {
    				return;
    			}

    			var jar = {};
    			// To prevent the for loop in the first place assign an empty array
    			// in case there are no cookies at all.
    			var cookies = document.cookie ? document.cookie.split('; ') : [];
    			var i = 0;

    			for (; i < cookies.length; i++) {
    				var parts = cookies[i].split('=');
    				var cookie = parts.slice(1).join('=');

    				if (!json && cookie.charAt(0) === '"') {
    					cookie = cookie.slice(1, -1);
    				}

    				try {
    					var name = decode(parts[0]);
    					cookie = (converter.read || converter)(cookie, name) ||
    						decode(cookie);

    					if (json) {
    						try {
    							cookie = JSON.parse(cookie);
    						} catch (e) {}
    					}

    					jar[name] = cookie;

    					if (key === name) {
    						break;
    					}
    				} catch (e) {}
    			}

    			return key ? jar[key] : jar;
    		}

    		api.set = set;
    		api.get = function (key) {
    			return get(key, false /* read as raw */);
    		};
    		api.getJSON = function (key) {
    			return get(key, true /* read as json */);
    		};
    		api.remove = function (key, attributes) {
    			set(key, '', extend(attributes, {
    				expires: -1
    			}));
    		};

    		api.defaults = {};

    		api.withConverter = init;

    		return api;
    	}

    	return init(function () {});
    }));
    }(js_cookie));

    // Unique ID creation requires a high quality random # generator. In the browser we therefore
    // require the crypto API and do not support built-in fallback to lower quality random number
    // generators (like Math.random()).
    var getRandomValues;
    var rnds8 = new Uint8Array(16);
    function rng() {
      // lazy load so that environments that need to polyfill have a chance to do so
      if (!getRandomValues) {
        // getRandomValues needs to be invoked in a context where "this" is a Crypto implementation. Also,
        // find the complete implementation of crypto (msCrypto) on IE11.
        getRandomValues = typeof crypto !== 'undefined' && crypto.getRandomValues && crypto.getRandomValues.bind(crypto) || typeof msCrypto !== 'undefined' && typeof msCrypto.getRandomValues === 'function' && msCrypto.getRandomValues.bind(msCrypto);

        if (!getRandomValues) {
          throw new Error('crypto.getRandomValues() not supported. See https://github.com/uuidjs/uuid#getrandomvalues-not-supported');
        }
      }

      return getRandomValues(rnds8);
    }

    var REGEX = /^(?:[0-9a-f]{8}-[0-9a-f]{4}-[1-5][0-9a-f]{3}-[89ab][0-9a-f]{3}-[0-9a-f]{12}|00000000-0000-0000-0000-000000000000)$/i;

    function validate(uuid) {
      return typeof uuid === 'string' && REGEX.test(uuid);
    }

    /**
     * Convert array of 16 byte values to UUID string format of the form:
     * XXXXXXXX-XXXX-XXXX-XXXX-XXXXXXXXXXXX
     */

    var byteToHex = [];

    for (var i = 0; i < 256; ++i) {
      byteToHex.push((i + 0x100).toString(16).substr(1));
    }

    function stringify(arr) {
      var offset = arguments.length > 1 && arguments[1] !== undefined ? arguments[1] : 0;
      // Note: Be careful editing this code!  It's been tuned for performance
      // and works in ways you may not expect. See https://github.com/uuidjs/uuid/pull/434
      var uuid = (byteToHex[arr[offset + 0]] + byteToHex[arr[offset + 1]] + byteToHex[arr[offset + 2]] + byteToHex[arr[offset + 3]] + '-' + byteToHex[arr[offset + 4]] + byteToHex[arr[offset + 5]] + '-' + byteToHex[arr[offset + 6]] + byteToHex[arr[offset + 7]] + '-' + byteToHex[arr[offset + 8]] + byteToHex[arr[offset + 9]] + '-' + byteToHex[arr[offset + 10]] + byteToHex[arr[offset + 11]] + byteToHex[arr[offset + 12]] + byteToHex[arr[offset + 13]] + byteToHex[arr[offset + 14]] + byteToHex[arr[offset + 15]]).toLowerCase(); // Consistency check for valid UUID.  If this throws, it's likely due to one
      // of the following:
      // - One or more input array values don't map to a hex octet (leading to
      // "undefined" in the uuid)
      // - Invalid input values for the RFC `version` or `variant` fields

      if (!validate(uuid)) {
        throw TypeError('Stringified UUID is invalid');
      }

      return uuid;
    }

    //
    // Inspired by https://github.com/LiosK/UUID.js
    // and http://docs.python.org/library/uuid.html

    var _nodeId;

    var _clockseq; // Previous uuid creation time


    var _lastMSecs = 0;
    var _lastNSecs = 0; // See https://github.com/uuidjs/uuid for API details

    function v1(options, buf, offset) {
      var i = buf && offset || 0;
      var b = buf || new Array(16);
      options = options || {};
      var node = options.node || _nodeId;
      var clockseq = options.clockseq !== undefined ? options.clockseq : _clockseq; // node and clockseq need to be initialized to random values if they're not
      // specified.  We do this lazily to minimize issues related to insufficient
      // system entropy.  See #189

      if (node == null || clockseq == null) {
        var seedBytes = options.random || (options.rng || rng)();

        if (node == null) {
          // Per 4.5, create and 48-bit node id, (47 random bits + multicast bit = 1)
          node = _nodeId = [seedBytes[0] | 0x01, seedBytes[1], seedBytes[2], seedBytes[3], seedBytes[4], seedBytes[5]];
        }

        if (clockseq == null) {
          // Per 4.2.2, randomize (14 bit) clockseq
          clockseq = _clockseq = (seedBytes[6] << 8 | seedBytes[7]) & 0x3fff;
        }
      } // UUID timestamps are 100 nano-second units since the Gregorian epoch,
      // (1582-10-15 00:00).  JSNumbers aren't precise enough for this, so
      // time is handled internally as 'msecs' (integer milliseconds) and 'nsecs'
      // (100-nanoseconds offset from msecs) since unix epoch, 1970-01-01 00:00.


      var msecs = options.msecs !== undefined ? options.msecs : Date.now(); // Per 4.2.1.2, use count of uuid's generated during the current clock
      // cycle to simulate higher resolution clock

      var nsecs = options.nsecs !== undefined ? options.nsecs : _lastNSecs + 1; // Time since last uuid creation (in msecs)

      var dt = msecs - _lastMSecs + (nsecs - _lastNSecs) / 10000; // Per 4.2.1.2, Bump clockseq on clock regression

      if (dt < 0 && options.clockseq === undefined) {
        clockseq = clockseq + 1 & 0x3fff;
      } // Reset nsecs if clock regresses (new clockseq) or we've moved onto a new
      // time interval


      if ((dt < 0 || msecs > _lastMSecs) && options.nsecs === undefined) {
        nsecs = 0;
      } // Per 4.2.1.2 Throw error if too many uuids are requested


      if (nsecs >= 10000) {
        throw new Error("uuid.v1(): Can't create more than 10M uuids/sec");
      }

      _lastMSecs = msecs;
      _lastNSecs = nsecs;
      _clockseq = clockseq; // Per 4.1.4 - Convert from unix epoch to Gregorian epoch

      msecs += 12219292800000; // `time_low`

      var tl = ((msecs & 0xfffffff) * 10000 + nsecs) % 0x100000000;
      b[i++] = tl >>> 24 & 0xff;
      b[i++] = tl >>> 16 & 0xff;
      b[i++] = tl >>> 8 & 0xff;
      b[i++] = tl & 0xff; // `time_mid`

      var tmh = msecs / 0x100000000 * 10000 & 0xfffffff;
      b[i++] = tmh >>> 8 & 0xff;
      b[i++] = tmh & 0xff; // `time_high_and_version`

      b[i++] = tmh >>> 24 & 0xf | 0x10; // include version

      b[i++] = tmh >>> 16 & 0xff; // `clock_seq_hi_and_reserved` (Per 4.2.2 - include variant)

      b[i++] = clockseq >>> 8 | 0x80; // `clock_seq_low`

      b[i++] = clockseq & 0xff; // `node`

      for (var n = 0; n < 6; ++n) {
        b[i + n] = node[n];
      }

      return buf || stringify(b);
    }

    function parse(uuid) {
      if (!validate(uuid)) {
        throw TypeError('Invalid UUID');
      }

      var v;
      var arr = new Uint8Array(16); // Parse ########-....-....-....-............

      arr[0] = (v = parseInt(uuid.slice(0, 8), 16)) >>> 24;
      arr[1] = v >>> 16 & 0xff;
      arr[2] = v >>> 8 & 0xff;
      arr[3] = v & 0xff; // Parse ........-####-....-....-............

      arr[4] = (v = parseInt(uuid.slice(9, 13), 16)) >>> 8;
      arr[5] = v & 0xff; // Parse ........-....-####-....-............

      arr[6] = (v = parseInt(uuid.slice(14, 18), 16)) >>> 8;
      arr[7] = v & 0xff; // Parse ........-....-....-####-............

      arr[8] = (v = parseInt(uuid.slice(19, 23), 16)) >>> 8;
      arr[9] = v & 0xff; // Parse ........-....-....-....-############
      // (Use "/" to avoid 32-bit truncation when bit-shifting high-order bytes)

      arr[10] = (v = parseInt(uuid.slice(24, 36), 16)) / 0x10000000000 & 0xff;
      arr[11] = v / 0x100000000 & 0xff;
      arr[12] = v >>> 24 & 0xff;
      arr[13] = v >>> 16 & 0xff;
      arr[14] = v >>> 8 & 0xff;
      arr[15] = v & 0xff;
      return arr;
    }

    function stringToBytes(str) {
      str = unescape(encodeURIComponent(str)); // UTF8 escape

      var bytes = [];

      for (var i = 0; i < str.length; ++i) {
        bytes.push(str.charCodeAt(i));
      }

      return bytes;
    }

    var DNS = '6ba7b810-9dad-11d1-80b4-00c04fd430c8';
    var URL = '6ba7b811-9dad-11d1-80b4-00c04fd430c8';
    function v35 (name, version, hashfunc) {
      function generateUUID(value, namespace, buf, offset) {
        if (typeof value === 'string') {
          value = stringToBytes(value);
        }

        if (typeof namespace === 'string') {
          namespace = parse(namespace);
        }

        if (namespace.length !== 16) {
          throw TypeError('Namespace must be array-like (16 iterable integer values, 0-255)');
        } // Compute hash of namespace and value, Per 4.3
        // Future: Use spread syntax when supported on all platforms, e.g. `bytes =
        // hashfunc([...namespace, ... value])`


        var bytes = new Uint8Array(16 + value.length);
        bytes.set(namespace);
        bytes.set(value, namespace.length);
        bytes = hashfunc(bytes);
        bytes[6] = bytes[6] & 0x0f | version;
        bytes[8] = bytes[8] & 0x3f | 0x80;

        if (buf) {
          offset = offset || 0;

          for (var i = 0; i < 16; ++i) {
            buf[offset + i] = bytes[i];
          }

          return buf;
        }

        return stringify(bytes);
      } // Function#name is not settable on some platforms (#270)


      try {
        generateUUID.name = name; // eslint-disable-next-line no-empty
      } catch (err) {} // For CommonJS default export support


      generateUUID.DNS = DNS;
      generateUUID.URL = URL;
      return generateUUID;
    }

    /*
     * Browser-compatible JavaScript MD5
     *
     * Modification of JavaScript MD5
     * https://github.com/blueimp/JavaScript-MD5
     *
     * Copyright 2011, Sebastian Tschan
     * https://blueimp.net
     *
     * Licensed under the MIT license:
     * https://opensource.org/licenses/MIT
     *
     * Based on
     * A JavaScript implementation of the RSA Data Security, Inc. MD5 Message
     * Digest Algorithm, as defined in RFC 1321.
     * Version 2.2 Copyright (C) Paul Johnston 1999 - 2009
     * Other contributors: Greg Holt, Andrew Kepert, Ydnar, Lostinet
     * Distributed under the BSD License
     * See http://pajhome.org.uk/crypt/md5 for more info.
     */
    function md5(bytes) {
      if (typeof bytes === 'string') {
        var msg = unescape(encodeURIComponent(bytes)); // UTF8 escape

        bytes = new Uint8Array(msg.length);

        for (var i = 0; i < msg.length; ++i) {
          bytes[i] = msg.charCodeAt(i);
        }
      }

      return md5ToHexEncodedArray(wordsToMd5(bytesToWords(bytes), bytes.length * 8));
    }
    /*
     * Convert an array of little-endian words to an array of bytes
     */


    function md5ToHexEncodedArray(input) {
      var output = [];
      var length32 = input.length * 32;
      var hexTab = '0123456789abcdef';

      for (var i = 0; i < length32; i += 8) {
        var x = input[i >> 5] >>> i % 32 & 0xff;
        var hex = parseInt(hexTab.charAt(x >>> 4 & 0x0f) + hexTab.charAt(x & 0x0f), 16);
        output.push(hex);
      }

      return output;
    }
    /**
     * Calculate output length with padding and bit length
     */


    function getOutputLength(inputLength8) {
      return (inputLength8 + 64 >>> 9 << 4) + 14 + 1;
    }
    /*
     * Calculate the MD5 of an array of little-endian words, and a bit length.
     */


    function wordsToMd5(x, len) {
      /* append padding */
      x[len >> 5] |= 0x80 << len % 32;
      x[getOutputLength(len) - 1] = len;
      var a = 1732584193;
      var b = -271733879;
      var c = -1732584194;
      var d = 271733878;

      for (var i = 0; i < x.length; i += 16) {
        var olda = a;
        var oldb = b;
        var oldc = c;
        var oldd = d;
        a = md5ff(a, b, c, d, x[i], 7, -680876936);
        d = md5ff(d, a, b, c, x[i + 1], 12, -389564586);
        c = md5ff(c, d, a, b, x[i + 2], 17, 606105819);
        b = md5ff(b, c, d, a, x[i + 3], 22, -1044525330);
        a = md5ff(a, b, c, d, x[i + 4], 7, -176418897);
        d = md5ff(d, a, b, c, x[i + 5], 12, 1200080426);
        c = md5ff(c, d, a, b, x[i + 6], 17, -1473231341);
        b = md5ff(b, c, d, a, x[i + 7], 22, -45705983);
        a = md5ff(a, b, c, d, x[i + 8], 7, 1770035416);
        d = md5ff(d, a, b, c, x[i + 9], 12, -1958414417);
        c = md5ff(c, d, a, b, x[i + 10], 17, -42063);
        b = md5ff(b, c, d, a, x[i + 11], 22, -1990404162);
        a = md5ff(a, b, c, d, x[i + 12], 7, 1804603682);
        d = md5ff(d, a, b, c, x[i + 13], 12, -40341101);
        c = md5ff(c, d, a, b, x[i + 14], 17, -1502002290);
        b = md5ff(b, c, d, a, x[i + 15], 22, 1236535329);
        a = md5gg(a, b, c, d, x[i + 1], 5, -165796510);
        d = md5gg(d, a, b, c, x[i + 6], 9, -1069501632);
        c = md5gg(c, d, a, b, x[i + 11], 14, 643717713);
        b = md5gg(b, c, d, a, x[i], 20, -373897302);
        a = md5gg(a, b, c, d, x[i + 5], 5, -701558691);
        d = md5gg(d, a, b, c, x[i + 10], 9, 38016083);
        c = md5gg(c, d, a, b, x[i + 15], 14, -660478335);
        b = md5gg(b, c, d, a, x[i + 4], 20, -405537848);
        a = md5gg(a, b, c, d, x[i + 9], 5, 568446438);
        d = md5gg(d, a, b, c, x[i + 14], 9, -1019803690);
        c = md5gg(c, d, a, b, x[i + 3], 14, -187363961);
        b = md5gg(b, c, d, a, x[i + 8], 20, 1163531501);
        a = md5gg(a, b, c, d, x[i + 13], 5, -1444681467);
        d = md5gg(d, a, b, c, x[i + 2], 9, -51403784);
        c = md5gg(c, d, a, b, x[i + 7], 14, 1735328473);
        b = md5gg(b, c, d, a, x[i + 12], 20, -1926607734);
        a = md5hh(a, b, c, d, x[i + 5], 4, -378558);
        d = md5hh(d, a, b, c, x[i + 8], 11, -2022574463);
        c = md5hh(c, d, a, b, x[i + 11], 16, 1839030562);
        b = md5hh(b, c, d, a, x[i + 14], 23, -35309556);
        a = md5hh(a, b, c, d, x[i + 1], 4, -1530992060);
        d = md5hh(d, a, b, c, x[i + 4], 11, 1272893353);
        c = md5hh(c, d, a, b, x[i + 7], 16, -155497632);
        b = md5hh(b, c, d, a, x[i + 10], 23, -1094730640);
        a = md5hh(a, b, c, d, x[i + 13], 4, 681279174);
        d = md5hh(d, a, b, c, x[i], 11, -358537222);
        c = md5hh(c, d, a, b, x[i + 3], 16, -722521979);
        b = md5hh(b, c, d, a, x[i + 6], 23, 76029189);
        a = md5hh(a, b, c, d, x[i + 9], 4, -640364487);
        d = md5hh(d, a, b, c, x[i + 12], 11, -421815835);
        c = md5hh(c, d, a, b, x[i + 15], 16, 530742520);
        b = md5hh(b, c, d, a, x[i + 2], 23, -995338651);
        a = md5ii(a, b, c, d, x[i], 6, -198630844);
        d = md5ii(d, a, b, c, x[i + 7], 10, 1126891415);
        c = md5ii(c, d, a, b, x[i + 14], 15, -1416354905);
        b = md5ii(b, c, d, a, x[i + 5], 21, -57434055);
        a = md5ii(a, b, c, d, x[i + 12], 6, 1700485571);
        d = md5ii(d, a, b, c, x[i + 3], 10, -1894986606);
        c = md5ii(c, d, a, b, x[i + 10], 15, -1051523);
        b = md5ii(b, c, d, a, x[i + 1], 21, -2054922799);
        a = md5ii(a, b, c, d, x[i + 8], 6, 1873313359);
        d = md5ii(d, a, b, c, x[i + 15], 10, -30611744);
        c = md5ii(c, d, a, b, x[i + 6], 15, -1560198380);
        b = md5ii(b, c, d, a, x[i + 13], 21, 1309151649);
        a = md5ii(a, b, c, d, x[i + 4], 6, -145523070);
        d = md5ii(d, a, b, c, x[i + 11], 10, -1120210379);
        c = md5ii(c, d, a, b, x[i + 2], 15, 718787259);
        b = md5ii(b, c, d, a, x[i + 9], 21, -343485551);
        a = safeAdd(a, olda);
        b = safeAdd(b, oldb);
        c = safeAdd(c, oldc);
        d = safeAdd(d, oldd);
      }

      return [a, b, c, d];
    }
    /*
     * Convert an array bytes to an array of little-endian words
     * Characters >255 have their high-byte silently ignored.
     */


    function bytesToWords(input) {
      if (input.length === 0) {
        return [];
      }

      var length8 = input.length * 8;
      var output = new Uint32Array(getOutputLength(length8));

      for (var i = 0; i < length8; i += 8) {
        output[i >> 5] |= (input[i / 8] & 0xff) << i % 32;
      }

      return output;
    }
    /*
     * Add integers, wrapping at 2^32. This uses 16-bit operations internally
     * to work around bugs in some JS interpreters.
     */


    function safeAdd(x, y) {
      var lsw = (x & 0xffff) + (y & 0xffff);
      var msw = (x >> 16) + (y >> 16) + (lsw >> 16);
      return msw << 16 | lsw & 0xffff;
    }
    /*
     * Bitwise rotate a 32-bit number to the left.
     */


    function bitRotateLeft(num, cnt) {
      return num << cnt | num >>> 32 - cnt;
    }
    /*
     * These functions implement the four basic operations the algorithm uses.
     */


    function md5cmn(q, a, b, x, s, t) {
      return safeAdd(bitRotateLeft(safeAdd(safeAdd(a, q), safeAdd(x, t)), s), b);
    }

    function md5ff(a, b, c, d, x, s, t) {
      return md5cmn(b & c | ~b & d, a, b, x, s, t);
    }

    function md5gg(a, b, c, d, x, s, t) {
      return md5cmn(b & d | c & ~d, a, b, x, s, t);
    }

    function md5hh(a, b, c, d, x, s, t) {
      return md5cmn(b ^ c ^ d, a, b, x, s, t);
    }

    function md5ii(a, b, c, d, x, s, t) {
      return md5cmn(c ^ (b | ~d), a, b, x, s, t);
    }

    var v3 = v35('v3', 0x30, md5);

    function v4(options, buf, offset) {
      options = options || {};
      var rnds = options.random || (options.rng || rng)(); // Per 4.4, set bits for version and `clock_seq_hi_and_reserved`

      rnds[6] = rnds[6] & 0x0f | 0x40;
      rnds[8] = rnds[8] & 0x3f | 0x80; // Copy bytes to buffer, if provided

      if (buf) {
        offset = offset || 0;

        for (var i = 0; i < 16; ++i) {
          buf[offset + i] = rnds[i];
        }

        return buf;
      }

      return stringify(rnds);
    }

    // Adapted from Chris Veness' SHA1 code at
    // http://www.movable-type.co.uk/scripts/sha1.html
    function f(s, x, y, z) {
      switch (s) {
        case 0:
          return x & y ^ ~x & z;

        case 1:
          return x ^ y ^ z;

        case 2:
          return x & y ^ x & z ^ y & z;

        case 3:
          return x ^ y ^ z;
      }
    }

    function ROTL(x, n) {
      return x << n | x >>> 32 - n;
    }

    function sha1(bytes) {
      var K = [0x5a827999, 0x6ed9eba1, 0x8f1bbcdc, 0xca62c1d6];
      var H = [0x67452301, 0xefcdab89, 0x98badcfe, 0x10325476, 0xc3d2e1f0];

      if (typeof bytes === 'string') {
        var msg = unescape(encodeURIComponent(bytes)); // UTF8 escape

        bytes = [];

        for (var i = 0; i < msg.length; ++i) {
          bytes.push(msg.charCodeAt(i));
        }
      } else if (!Array.isArray(bytes)) {
        // Convert Array-like to Array
        bytes = Array.prototype.slice.call(bytes);
      }

      bytes.push(0x80);
      var l = bytes.length / 4 + 2;
      var N = Math.ceil(l / 16);
      var M = new Array(N);

      for (var _i = 0; _i < N; ++_i) {
        var arr = new Uint32Array(16);

        for (var j = 0; j < 16; ++j) {
          arr[j] = bytes[_i * 64 + j * 4] << 24 | bytes[_i * 64 + j * 4 + 1] << 16 | bytes[_i * 64 + j * 4 + 2] << 8 | bytes[_i * 64 + j * 4 + 3];
        }

        M[_i] = arr;
      }

      M[N - 1][14] = (bytes.length - 1) * 8 / Math.pow(2, 32);
      M[N - 1][14] = Math.floor(M[N - 1][14]);
      M[N - 1][15] = (bytes.length - 1) * 8 & 0xffffffff;

      for (var _i2 = 0; _i2 < N; ++_i2) {
        var W = new Uint32Array(80);

        for (var t = 0; t < 16; ++t) {
          W[t] = M[_i2][t];
        }

        for (var _t = 16; _t < 80; ++_t) {
          W[_t] = ROTL(W[_t - 3] ^ W[_t - 8] ^ W[_t - 14] ^ W[_t - 16], 1);
        }

        var a = H[0];
        var b = H[1];
        var c = H[2];
        var d = H[3];
        var e = H[4];

        for (var _t2 = 0; _t2 < 80; ++_t2) {
          var s = Math.floor(_t2 / 20);
          var T = ROTL(a, 5) + f(s, b, c, d) + e + K[s] + W[_t2] >>> 0;
          e = d;
          d = c;
          c = ROTL(b, 30) >>> 0;
          b = a;
          a = T;
        }

        H[0] = H[0] + a >>> 0;
        H[1] = H[1] + b >>> 0;
        H[2] = H[2] + c >>> 0;
        H[3] = H[3] + d >>> 0;
        H[4] = H[4] + e >>> 0;
      }

      return [H[0] >> 24 & 0xff, H[0] >> 16 & 0xff, H[0] >> 8 & 0xff, H[0] & 0xff, H[1] >> 24 & 0xff, H[1] >> 16 & 0xff, H[1] >> 8 & 0xff, H[1] & 0xff, H[2] >> 24 & 0xff, H[2] >> 16 & 0xff, H[2] >> 8 & 0xff, H[2] & 0xff, H[3] >> 24 & 0xff, H[3] >> 16 & 0xff, H[3] >> 8 & 0xff, H[3] & 0xff, H[4] >> 24 & 0xff, H[4] >> 16 & 0xff, H[4] >> 8 & 0xff, H[4] & 0xff];
    }

    var v5 = v35('v5', 0x50, sha1);

    var nil = '00000000-0000-0000-0000-000000000000';

    function version(uuid) {
      if (!validate(uuid)) {
        throw TypeError('Invalid UUID');
      }

      return parseInt(uuid.substr(14, 1), 16);
    }

    var esmBrowser = /*#__PURE__*/Object.freeze({
        __proto__: null,
        v1: v1,
        v3: v3,
        v4: v4,
        v5: v5,
        NIL: nil,
        version: version,
        validate: validate,
        stringify: stringify,
        parse: parse
    });

    var require$$1 = /*@__PURE__*/getAugmentedNamespace(esmBrowser);

    var CookieKey$1 = {};

    Object.defineProperty(CookieKey$1, "__esModule", { value: true });
    /**
     * Ключ, по которому в Cookie's хранится значение.
     */
    var CookieKey;
    (function (CookieKey) {
        /**
         * Идентификатор сессии.
         */
        CookieKey["SESSION_ID"] = "dvmclcks";
        /**
         * Уникальный идентификатор устройства.
         */
        CookieKey["DEVICE_ID"] = "dvmclckf";
        /**
         * Уникальный идентификатор визита пользователя на сайт.
         */
        CookieKey["VISIT_ID"] = "dvmclckv";
    })(CookieKey || (CookieKey = {}));
    CookieKey$1.default = CookieKey;

    Object.defineProperty(DataHelper$1, "__esModule", { value: true });
    var Cookie = js_cookie.exports;
    var uuid_1 = require$$1;
    var CookieKey_1 = CookieKey$1;
    /**
     * Содержит методы для получения пользовательских данных из браузера.
     */
    var DataHelper = /** @class */ (function () {
        function DataHelper() {
        }
        /**
         * Возвращает полный адрес текущей страницы (к примеру,
         * `https://sample.com/pathname?query=`). Если адрес определить не удалось
         * (допустим, код был вызван на сервере), метод возвращает `undefined`.
         */
        DataHelper.getHref = function () {
            return location.href;
        };
        /**
         * Возвращает домен, который используется для хранения куков.
         * @param hostname Полное название хоста.
         */
        DataHelper.getDomain = function (hostname) {
            if (hostname === void 0) { hostname = location.hostname; }
            var ip = /^\d{1,3}\.\d{1,3}\.\d{1,3}\.\d{1,3}$/.test(hostname);
            if (ip) {
                return hostname;
            }
            var match = hostname.match(/[^.]+\.[^.]+$/);
            if (match == null) {
                return hostname;
            }
            return match[0];
        };
        /**
         * Возвращает уникальный идентификатор устройства, на котором пользователь
         * просматривает сайт.
         */
        DataHelper.getDeviceId = function () {
            var deviceId = Cookie.get(CookieKey_1.default.DEVICE_ID);
            if (deviceId) {
                return deviceId;
            }
            deviceId = uuid_1.v4();
            Cookie.set(CookieKey_1.default.DEVICE_ID, deviceId, {
                domain: this.getDomain(),
                expires: 365,
            });
            return deviceId;
        };
        /**
         * Возвращает уникальный идентификатор сессии клиента.
         * @param renew Указывает, что идентификатор следует обновить.
         */
        DataHelper.getSessionId = function (renew) {
            var id = Cookie.get(CookieKey_1.default.SESSION_ID);
            if (renew || !id) {
                id = uuid_1.v4();
                Cookie.set(CookieKey_1.default.SESSION_ID, id, { domain: this.getDomain() });
            }
            return id;
        };
        /**
         * Возвращает `user-agent` текущего устройства пользователя или `undefined`,
         * если его не удалось определить.
         *
         * Определение происходит на основе свойства `navigator.userAgent`.
         */
        DataHelper.getUserAgent = function () {
            return navigator.userAgent;
        };
        /**
         * Возвращает содержимое заголовка Referrer запроса к текущей странице.
         */
        DataHelper.getReferrer = function () {
            return document.referrer;
        };
        /**
         * Возвращает коллекцию параметров адреса страницы. По умолчанию разбирается
         * текущий адрес.
         * @param search Опционально, часть параметров адреса.
         */
        DataHelper.getSearch = function (search) {
            if (search === void 0) { search = location.search; }
            var pureSearch = search.replace(/^\?/, '');
            var chunks = pureSearch.split(/&/g);
            var length = chunks.length;
            var params = {};
            for (var i = 0; i < length; i += 1) {
                var chunk = chunks[i];
                if (!chunk) {
                    continue;
                }
                var _a = chunk.split('='), title = _a[0], _b = _a[1], value = _b === void 0 ? '' : _b;
                var key = decodeURIComponent(title);
                if (params[key] == null) {
                    params[key] = decodeURIComponent(value);
                }
            }
            return params;
        };
        /**
         * Возвращает высоту экрана пользователя.
         */
        DataHelper.getScreenHeight = function () {
            return screen.height;
        };
        /**
         * Возвращает ширину экрана пользователя.
         */
        DataHelper.getScreenWidth = function () {
            return screen.width;
        };
        /**
         * Возвращает `true`, если пользователь использует режим "Инкогнито".
         * @see https://gist.github.com/jherax/a81c8c132d09cc354a0e2cb911841ff1#file-is-private-mode-ts
         */
        /* istanbul ignore next */
        DataHelper.getIsIncognito = function () {
            return new Promise(function (resolve) {
                var yes = function () { return resolve(true); }; // is in private mode
                var not = function () { return resolve(false); }; // not in private mode
                function detectChromeOpera() {
                    var _a;
                    // https://developers.google.com/web/updates/2017/08/estimating-available-storage-space
                    var isChromeOpera = /(?=.*(opera|chrome)).*/i.test(navigator.userAgent) &&
                        ((_a = navigator.storage) === null || _a === void 0 ? void 0 : _a.estimate);
                    if (isChromeOpera) {
                        navigator.storage.estimate().then(function (_a) {
                            var quota = _a.quota;
                            (quota !== null && quota !== void 0 ? quota : 0) < 120000000 ? yes() : not();
                        });
                    }
                    return Boolean(isChromeOpera);
                }
                function detectFirefox() {
                    var isMozillaFirefox = 'MozAppearance' in document.documentElement.style;
                    if (isMozillaFirefox) {
                        if (indexedDB == null)
                            yes();
                        else {
                            var db = indexedDB.open('inPrivate');
                            db.onsuccess = not;
                            db.onerror = yes;
                        }
                    }
                    return isMozillaFirefox;
                }
                function detectSafari() {
                    var isSafari = navigator.userAgent.match(/Version\/([0-9\._]+).*Safari/);
                    if (isSafari) {
                        var testLocalStorage = function () {
                            try {
                                if (localStorage.length)
                                    not();
                                else {
                                    localStorage.setItem('inPrivate', '0');
                                    localStorage.removeItem('inPrivate');
                                    not();
                                }
                            }
                            catch (_) {
                                // Safari only enables cookie in private mode
                                // if cookie is disabled, then all client side storage is disabled
                                // if all client side storage is disabled, then there is no point
                                // in using private mode
                                navigator.cookieEnabled ? yes() : not();
                            }
                            return true;
                        };
                        var version = parseInt(isSafari[1], 10);
                        if (version < 11) {
                            return testLocalStorage();
                        }
                        try {
                            window.openDatabase(null, null, null, null);
                            not();
                        }
                        catch (_) {
                            yes();
                        }
                    }
                    return Boolean(isSafari);
                }
                function detectEdgeIE10() {
                    var isEdgeIE10 = 
                    // @ts-ignore
                    !window.indexedDB && (window.PointerEvent || window.MSPointerEvent);
                    if (isEdgeIE10) {
                        yes();
                    }
                    return Boolean(isEdgeIE10);
                }
                // when a browser is detected, it runs tests for that browser
                // and skips pointless testing for other browsers.
                if (detectChromeOpera()) {
                    return;
                }
                if (detectFirefox()) {
                    return;
                }
                if (detectSafari()) {
                    return;
                }
                if (detectEdgeIE10()) {
                    return;
                }
                // default navigation mode
                return not();
            });
        };
        /**
         * Возвращает номер временной зоны пользователя в формате 'GMT+3'.
         * @param time Объект даты / времени, из которого нужно извлечь смещение.
         */
        DataHelper.getTimeZone = function (time) {
            if (time === void 0) { time = new Date(); }
            var offset = time.getTimezoneOffset();
            offset *= -1;
            offset /= 60;
            offset = Math.ceil(offset);
            // Для timezone важен знак, а `Math.ceil` может вернуть `-0`, что ломает
            // проверку вида `=== 0`.
            /* istanbul ignore next */
            return offset === 0 ? 0 : offset;
        };
        /**
         * Возвращает текущие дату и время.
         */
        DataHelper.getTime = function () {
            return new Date();
        };
        /**
         * Возвращает уникальный идентификатор визита пользователя на сайт. Если
         * данный идентификатор ещё не был создан, возвращает `undefined`.
         */
        DataHelper.getVisitId = function () {
            return Cookie.get(CookieKey_1.default.VISIT_ID);
        };
        /**
         * Генерирует и записывает в cookies уникальный идентификатор визита
         * пользователя на сайт. Данный идентификатор будет валидным, пока длится
         * браузерная сессия.
         */
        DataHelper.setVisitId = function () {
            if (this.getVisitId()) {
                return;
            }
            var id = uuid_1.v4();
            Cookie.set(CookieKey_1.default.VISIT_ID, id, {
                domain: this.getDomain(),
            });
        };
        return DataHelper;
    }());
    DataHelper$1.default = DataHelper;

    var RequestHelper$1 = {};

    Object.defineProperty(RequestHelper$1, "__esModule", { value: true });
    /**
     * Содержит методы для формирования запроса к API.
     */
    var RequestHelper = /** @class */ (function () {
        function RequestHelper() {
        }
        /**
         * Создаёт заголовки запроса к API из указанной коллекции значений.
         * @param values Коллекция значений.
         */
        RequestHelper.createHeaders = function (values) {
            var keys = Object.keys(values);
            var length = keys.length;
            var headers = {};
            for (var i = 0; i < length; i += 1) {
                var key = keys[i];
                var value = values[key];
                if (value != null) {
                    headers[key] =
                        typeof value === 'boolean' ? String(Number(value)) : String(value);
                }
            }
            return headers;
        };
        /**
         * Создаёт тело запроса к API из указанной коллекции значений.
         * @param values Коллекция значений.
         */
        RequestHelper.createBody = function (values) {
            var body = {};
            var keys = Object.keys(values);
            var length = keys.length;
            for (var i = 0; i < length; i += 1) {
                var key = keys[i];
                var value = values[key];
                if (value == null) {
                    body[key] = null;
                }
                else {
                    body[key] = typeof value === 'boolean' ? Number(value) : value;
                }
            }
            return JSON.stringify(body);
        };
        /**
         * Преобразует указанную дату и время в строку, пригодную для отправки в API.
         * @param time Дата и время.
         * @returns
         */
        RequestHelper.formatTime = function (time) {
            var stringify = function (value) {
                return value < 10 ? "0" + value : String(value);
            };
            var year = stringify(time.getFullYear());
            var month = stringify(time.getMonth() + 1);
            var days = stringify(time.getDate());
            var hours = stringify(time.getHours());
            var minutes = stringify(time.getMinutes());
            var seconds = stringify(time.getSeconds());
            return year + "-" + month + "-" + days + " " + hours + ":" + minutes + ":" + seconds;
        };
        /**
         * Преобразует смещенение относительно Гринвича (в часах) в строку, пригодную
         * для отправки в API.
         * @param offset Смещение (в часах) относительно нулевого меридиана.
         * @returns
         */
        RequestHelper.formatTimezone = function (offset) {
            var sign = offset >= 0 ? '+' : '';
            return "GMT" + sign + offset;
        };
        return RequestHelper;
    }());
    RequestHelper$1.default = RequestHelper;

    var __assign = (commonjsGlobal && commonjsGlobal.__assign) || function () {
        __assign = Object.assign || function(t) {
            for (var s, i = 1, n = arguments.length; i < n; i++) {
                s = arguments[i];
                for (var p in s) if (Object.prototype.hasOwnProperty.call(s, p))
                    t[p] = s[p];
            }
            return t;
        };
        return __assign.apply(this, arguments);
    };
    var __awaiter = (commonjsGlobal && commonjsGlobal.__awaiter) || function (thisArg, _arguments, P, generator) {
        function adopt(value) { return value instanceof P ? value : new P(function (resolve) { resolve(value); }); }
        return new (P || (P = Promise))(function (resolve, reject) {
            function fulfilled(value) { try { step(generator.next(value)); } catch (e) { reject(e); } }
            function rejected(value) { try { step(generator["throw"](value)); } catch (e) { reject(e); } }
            function step(result) { result.done ? resolve(result.value) : adopt(result.value).then(fulfilled, rejected); }
            step((generator = generator.apply(thisArg, _arguments || [])).next());
        });
    };
    var __generator = (commonjsGlobal && commonjsGlobal.__generator) || function (thisArg, body) {
        var _ = { label: 0, sent: function() { if (t[0] & 1) throw t[1]; return t[1]; }, trys: [], ops: [] }, f, y, t, g;
        return g = { next: verb(0), "throw": verb(1), "return": verb(2) }, typeof Symbol === "function" && (g[Symbol.iterator] = function() { return this; }), g;
        function verb(n) { return function (v) { return step([n, v]); }; }
        function step(op) {
            if (f) throw new TypeError("Generator is already executing.");
            while (_) try {
                if (f = 1, y && (t = op[0] & 2 ? y["return"] : op[0] ? y["throw"] || ((t = y["return"]) && t.call(y), 0) : y.next) && !(t = t.call(y, op[1])).done) return t;
                if (y = 0, t) op = [op[0] & 2, t.value];
                switch (op[0]) {
                    case 0: case 1: t = op; break;
                    case 4: _.label++; return { value: op[1], done: false };
                    case 5: _.label++; y = op[1]; op = [0]; continue;
                    case 7: op = _.ops.pop(); _.trys.pop(); continue;
                    default:
                        if (!(t = _.trys, t = t.length > 0 && t[t.length - 1]) && (op[0] === 6 || op[0] === 2)) { _ = 0; continue; }
                        if (op[0] === 3 && (!t || (op[1] > t[0] && op[1] < t[3]))) { _.label = op[1]; break; }
                        if (op[0] === 6 && _.label < t[1]) { _.label = t[1]; t = op; break; }
                        if (t && _.label < t[2]) { _.label = t[2]; _.ops.push(op); break; }
                        if (t[2]) _.ops.pop();
                        _.trys.pop(); continue;
                }
                op = body.call(thisArg, _);
            } catch (e) { op = [6, e]; y = 0; } finally { f = t = 0; }
            if (op[0] & 5) throw op[1]; return { value: op[0] ? op[1] : void 0, done: true };
        }
    };
    Object.defineProperty(Service$1, "__esModule", { value: true });
    var DataHelper_1 = DataHelper$1;
    var RequestHelper_1 = RequestHelper$1;
    /**
     * Сервис, предоставляющий методы для отправки событий в Clickhouse API.
     */
    var Service = /** @class */ (function () {
        /**
         * Создаёт экземпляр сервиса с указанной конфигурацией.
         * @param config Объект конфигурации сервиса.
         */
        function Service(config) {
            if (config === void 0) { config = {}; }
            this.config = config;
        }
        /**
         * Заполняет недостающие параметры указанного события значениями по
         * умолчанию.
         * @param event Событие.
         */
        Service.prototype.assignDefaults = function (event) {
            return __awaiter(this, void 0, void 0, function () {
                function isNotExists(key) {
                    return !Object.prototype.hasOwnProperty.call(event, key);
                }
                var _a, isUtmNotExists, search;
                return __generator(this, function (_b) {
                    switch (_b.label) {
                        case 0:
                            event.sessionId = DataHelper_1.default.getSessionId(event.logout);
                            if (isNotExists('deviceId')) {
                                event.deviceId = DataHelper_1.default.getDeviceId();
                            }
                            if (isNotExists('userAgent')) {
                                event.userAgent = DataHelper_1.default.getUserAgent();
                            }
                            if (isNotExists('referrer')) {
                                event.referrer = DataHelper_1.default.getReferrer();
                            }
                            if (isNotExists('screenHeight')) {
                                event.screenHeight = DataHelper_1.default.getScreenHeight();
                            }
                            if (isNotExists('screenWidth')) {
                                event.screenWidth = DataHelper_1.default.getScreenWidth();
                            }
                            if (!isNotExists('isIncognito')) return [3 /*break*/, 2];
                            _a = event;
                            return [4 /*yield*/, DataHelper_1.default.getIsIncognito()];
                        case 1:
                            _a.isIncognito = _b.sent();
                            _b.label = 2;
                        case 2:
                            if (isNotExists('time')) {
                                event.time = DataHelper_1.default.getTime();
                            }
                            if (isNotExists('timezone')) {
                                event.timezone = DataHelper_1.default.getTimeZone();
                            }
                            if (isNotExists('href')) {
                                event.href = DataHelper_1.default.getHref();
                            }
                            isUtmNotExists = isNotExists('utmCampaign') &&
                                isNotExists('utmContent') &&
                                isNotExists('utmSource') &&
                                isNotExists('utmMedium') &&
                                isNotExists('utmTerm');
                            if (isUtmNotExists) {
                                search = DataHelper_1.default.getSearch();
                                event.utmCampaign = search['utm_campaign'];
                                event.utmContent = search['utm_content'];
                                event.utmSource = search['utm_source'];
                                event.utmMedium = search['utm_medium'];
                                event.utmTerm = search['utm_term'];
                            }
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Вызывает пользовательский хук `beforeAssignDefaults` из конфигурации
         * сервиса для указанного события.
         * @param event Событие.
         */
        Service.prototype.beforeAssignDefaults = function (event) {
            return __awaiter(this, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.config.beforeAssignDefaults) return [3 /*break*/, 2];
                            result = this.config.beforeAssignDefaults(event);
                            return [4 /*yield*/, Promise.resolve(result)];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Вызывает пользовательский хук `beforeSend` из конфигурации сервиса для
         * указанного события.
         * @param event Событие.
         */
        Service.prototype.beforeSend = function (event) {
            return __awaiter(this, void 0, void 0, function () {
                var result;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.config.beforeSend) return [3 /*break*/, 2];
                            result = this.config.beforeSend(event);
                            return [4 /*yield*/, Promise.resolve(result)];
                        case 1:
                            _a.sent();
                            _a.label = 2;
                        case 2: return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Возвращает коллекцию заголовков запроса к API, полученную из указанного
         * события.
         * @param event Событие.
         */
        Service.prototype.getHeaders = function (event) {
            return __awaiter(this, void 0, void 0, function () {
                var _a;
                return __generator(this, function (_b) {
                    return [2 /*return*/, RequestHelper_1.default.createHeaders((_a = {},
                            _a["Content-Type"] = 'application/json',
                            _a["Accept"] = 'application/json',
                            _a["User-Agent"] = event.userAgent,
                            _a["X-UserID"] = event.userId,
                            _a["X-API-KEY"] = this.config.id || undefined,
                            _a["X-API-CLIENT-ID"] = this.config.clientId || undefined,
                            _a["X-SessionID"] = event.sessionId,
                            _a))];
                });
            });
        };
        /**
         * Возвращает тело запроса к API, полученное на основе указанного события.
         * @param event Событие.
         */
        Service.prototype.getBody = function (event) {
            return __awaiter(this, void 0, void 0, function () {
                return __generator(this, function (_a) {
                    return [2 /*return*/, RequestHelper_1.default.createBody({
                            event: event.name,
                            eventValue: event.payload,
                            fingerprintID: event.deviceId,
                            referer: event.referrer,
                            source: event.utmSource,
                            campaign: event.utmCampaign,
                            medium: event.utmMedium,
                            content: event.utmContent,
                            term: event.utmTerm,
                            screenHeight: event.screenHeight,
                            screenWidth: event.screenWidth,
                            isIncognito: event.isIncognito,
                            localTime: RequestHelper_1.default.formatTime(event.time),
                            testGroup: event.testGroup,
                            timeZone: RequestHelper_1.default.formatTimezone(event.timezone),
                            page: event.href,
                            operator: event.operator,
                            userType: event.userType,
                        })];
                });
            });
        };
        /**
         * Если сервис подключён к API, отправляет указанное событие на сервер. В
         * противном случае не делает ничего.
         * @param event Событие.
         */
        Service.prototype.fetch = function (event) {
            return __awaiter(this, void 0, void 0, function () {
                var headers, body;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            if (!this.config.url || !this.config.id || !this.config.clientId) {
                                return [2 /*return*/];
                            }
                            return [4 /*yield*/, this.getHeaders(event)];
                        case 1:
                            headers = _a.sent();
                            return [4 /*yield*/, this.getBody(event)];
                        case 2:
                            body = _a.sent();
                            return [4 /*yield*/, fetch(this.config.url, {
                                    headers: headers,
                                    body: body,
                                    method: 'post',
                                    mode: 'cors',
                                })];
                        case 3:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Если в конфигурации сервиса указан флаг `verbose`, логгирует указанное
         * событие. В противном случае не делает ничего.
         * @param event Событие.
         */
        Service.prototype.log = function (event) {
            if (!this.config.verbose || typeof console === 'undefined') {
                return;
            }
            console.debug('clickhouse_event', event);
        };
        /**
         * Отправляет указанное событие в Clickhouse API.
         * @param name Название события.
         * @param params Параметры события.
         */
        Service.prototype.send = function (name, params) {
            if (params === void 0) { params = {}; }
            return __awaiter(this, void 0, void 0, function () {
                var event;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            event = __assign({ name: name }, params);
                            return [4 /*yield*/, this.beforeAssignDefaults(event)];
                        case 1:
                            _a.sent();
                            return [4 /*yield*/, this.assignDefaults(event)];
                        case 2:
                            _a.sent();
                            return [4 /*yield*/, this.beforeSend(event)];
                        case 3:
                            _a.sent();
                            this.log(event);
                            return [4 /*yield*/, this.fetch(event)];
                        case 4:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        /**
         * Отправляет событие `visit` в Clickhouse API. Событие сингнализирует о
         * начале визита пользователя на сайт. Реальная отправка данного события
         * происходит только после начала браузерной сессии. Все последующие вызовы
         * метода ни к чему не приведут.
         *
         * Рекомендуется отправлять данное событие при `DOMContentLoaded` или первой
         * отрисовке приложения (если мы говорим о SPA).
         * @param params Параметры события.
         */
        Service.prototype.sendVisit = function (params) {
            if (params === void 0) { params = {}; }
            return __awaiter(this, void 0, void 0, function () {
                var visitId;
                return __generator(this, function (_a) {
                    switch (_a.label) {
                        case 0:
                            visitId = DataHelper_1.default.getVisitId();
                            if (visitId) {
                                return [2 /*return*/];
                            }
                            DataHelper_1.default.setVisitId();
                            return [4 /*yield*/, this.send('visit', params)];
                        case 1:
                            _a.sent();
                            return [2 /*return*/];
                    }
                });
            });
        };
        return Service;
    }());
    Service$1.default = Service;

    (function (exports) {
    Object.defineProperty(exports, "__esModule", { value: true });
    exports.Service = void 0;
    var Service_1 = Service$1;
    Object.defineProperty(exports, "Service", { enumerable: true, get: function () { return Service_1.default; } });
    }(dist));

    /**
     * Проверяет, является ли переданное значение событием.
     * @param value Значение.
     */
    function isEvent(value) {
        return typeof value === 'object' && typeof value.type === 'string';
    }

    /**
     * Экземпляр сервиса Clickhouse API, используемый в данный момент.
     */
    var service = new dist.Service();
    /**
     * Отправляет все события, сохранённые в указанном массиве и очищает его.
     * @param events Массив событий.
     */
    function flush(events) {
        while (events.length > 0) {
            var value = events.shift();
            if (!isEvent(value)) {
                continue;
            }
            var _a = value, type = _a.type, params = __rest(_a, ["type"]);
            if (type !== 'initialize') {
                service.send(type, params);
                continue;
            }
            var payload = params.payload;
            var config = {};
            if (typeof payload === 'object') {
                var beforeAssignDefaults = payload.beforeAssignDefaults, beforeSend = payload.beforeSend, verbose = payload.verbose, url = payload.url, id = payload.id, clientId = payload.clientId;
                config = { beforeAssignDefaults: beforeAssignDefaults, beforeSend: beforeSend, verbose: verbose, url: url, id: id, clientId: clientId };
            }
            service = new dist.Service(config);
            service.sendVisit();
        }
    }

    /**
     * Указывает, были ли добавлены специальные обработчики глобальному массиву
     * событий.
     */
    var isBootstrapped = false;
    /**
     * Находит глобальный массив с событиями метрики и проксирует его таким
     * образом, чтобы при изменении массива события отправлялись на сервер.
     */
    function bootstrap() {
        if (isBootstrapped) {
            return;
        }
        if (window.devimClickhouse == null) {
            window.devimClickhouse = [];
        }
        flush(window.devimClickhouse);
        window.devimClickhouse = new Proxy(window.devimClickhouse, {
            set: function (target, property, value) {
                // @ts-ignore
                target[property] = value;
                flush(target);
                return true;
            },
        });
        isBootstrapped = true;
    }

    if (typeof window !== 'undefined') {
        if (document.readyState === 'loading') {
            document.addEventListener('DOMContentLoaded', bootstrap, false);
        }
        else {
            bootstrap();
        }
    }

}());
